Gecode::ViewValNGL< View, Val, pc > Class Template Reference

View-value no-good literal. More...

`#include <view-val.hpp>`

## Public Member Functions

| ViewValNGL (Space &home, View x, Val n)
| Initialize for propagator p with view x and value n.
| ViewValNGL (Space &home, ViewValNGL &ngl)
| Constructor for cloning ngl.
virtual void | subscribe (Space &home, Propagator &p)
| Create subscription for no-good literal.
virtual void | cancel (Space &home, Propagator &p)
| Cancel subscription for no-good literal.
virtual void | reschedule (Space &home, Propagator &p)
| Schedule propagator p.
virtual size_t | dispose (Space &home)
| Dispose.
Public Member Functions inherited from Gecode::NGL
| NGL (void)
| Constructor for creation.
| NGL (Space &home)
| Constructor for creation.
| NGL (Space &home, NGL &ngl)
| Constructor for cloning ngl.
virtual NGL::Status | status (const Space &home) const =0
| Test the status of the no-good literal.
virtual ExecStatus | prune (Space &home)=0
| Propagate the negation of the no-good literal.
virtual NGL * | copy (Space &home)=0
| Create copy.
virtual bool | notice (void) const
| Whether dispose must always be called (returns false).
bool | leaf (void) const
| Test whether literal is a leaf.
NGL * | next (void) const
| Return pointer to next literal.
void | leaf (bool l)
| Mark literal as leaf or not.
void | next (NGL *n)
| Set pointer to next literal
NGL * | add (NGL *n, bool l)
| Add node n and mark it as leaf l and return n.
virtual | ~NGL (void)
| To avoid warnings.

## Protected Attributes

View | x
| The stored view.
Val | n
| The stored value.

## Additional Inherited Members

Public Types inherited from Gecode::NGL
enum | Status { FAILED , SUBSUMED , NONE }
| The status of a no-good literal. More...
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *s, Space &home)
| Return memory to space.
static void | operator delete (void *p)
| Needed for exceptions.
static void * | operator new (size_t s)
| Not used.

## Detailed Description

template<class View, class Val, PropCond pc>
class Gecode::ViewValNGL< View, Val, pc >

View-value no-good literal.

Definition at line 61 of file view-val.hpp.

## Constructor & Destructor Documentation

## ViewValNGL() [1/2]

template<class View, class Val, PropCond pc>

Gecode::ViewValNGL< View, Val, pc >::ViewValNGL | ( | Space & | home,
|  | View | x,
|  | Val | n )

inline

Initialize for propagator p with view x and value n.

Definition at line 183 of file view-val.hpp.

## ViewValNGL() [2/2]

template<class View, class Val, PropCond pc>

Gecode::ViewValNGL< View, Val, pc >::ViewValNGL | ( | Space & | home,
|  | ViewValNGL< View, Val, pc > & | ngl )

inline

Constructor for cloning ngl.

Definition at line 188 of file view-val.hpp.

## Member Function Documentation

## subscribe()

template<class View, class Val, PropCond pc>

void Gecode::ViewValNGL< View, Val, pc >::subscribe | ( | Space & | home,
|  | Propagator & | p )

virtual

Create subscription for no-good literal.

Implements Gecode::NGL.

Definition at line 195 of file view-val.hpp.

## cancel()

template<class View, class Val, PropCond pc>

void Gecode::ViewValNGL< View, Val, pc >::cancel | ( | Space & | home,
|  | Propagator & | p )

virtual

Cancel subscription for no-good literal.

Implements Gecode::NGL.

Definition at line 201 of file view-val.hpp.

## reschedule()

template<class View, class Val, PropCond pc>

void Gecode::ViewValNGL< View, Val, pc >::reschedule | ( | Space & | home,
|  | Propagator & | p )

virtual

Schedule propagator p.

Implements Gecode::NGL.

Definition at line 207 of file view-val.hpp.

## dispose()

template<class View, class Val, PropCond pc>

size_t Gecode::ViewValNGL< View, Val, pc >::dispose | ( | Space & | home | ) |

virtual

Dispose.

Reimplemented from Gecode::NGL.

Definition at line 213 of file view-val.hpp.

## Member Data Documentation

## x

template<class View, class Val, PropCond pc>

View Gecode::ViewValNGL< View, Val, pc >::x

protected

The stored view.

Definition at line 64 of file view-val.hpp.

## n

template<class View, class Val, PropCond pc>

Val Gecode::ViewValNGL< View, Val, pc >::n

protected

The stored value.

Definition at line 66 of file view-val.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/branch/view-val.hpp